unit KeyStatU;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls;

type
  TForm1 = class(TForm)
    StatusBar1: TStatusBar;
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  //Share the form's OnActivate handler with the Application
  //so we can update the key state when switching from
  //another app to ours
  Application.OnActivate := OnActivate
end;

procedure UpdateKeyState(Panel: TStatusPanel);
var
  Status: String;
begin

  if Odd(GetKeyState(vk_Capital)) then
    Status := 'CAPS ';
  if Odd(GetKeyState(vk_NumLock)) then
    Status := Status + 'NUM ';
  if Odd(GetKeyState(vk_Scroll)) then
    Status := Status + 'SCRL';
  Panel.Text := Status
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
  UpdateKeyState(StatusBar1.Panels[0])
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  //Since KeyPreview is True, we see pretty much
  //all keys that get pressed on this form
  if Key in [vk_Capital, vk_NumLock, vk_Scroll] then
    UpdateKeyState(StatusBar1.Panels[0])
end;

end.
