unit RunButton;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons;

type
  TRunButton = class;

  TRunEvent = procedure(Sender: TRunButton;
    Hdl: THandle; const CmdLine: String) of object;

  TRunButton = class(TSpeedButton)
  private
    FCommand: String;
    FOnRun: TRunEvent;
  protected
    procedure SetCommand(const Value: String);
  public
    procedure Click; override;
    function Run: Boolean; virtual;
  published
    property Command: String read FCommand write SetCommand;
    property OnRun: TRunEvent read FOnRun write FOnRun;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Samples', [TRunButton]);
end;

{ TRunButton }

procedure TRunButton.Click;
begin
  inherited;
  Run
end;

function TRunButton.Run: Boolean;
var
  SI: TStartupInfo;
  PI: TProcessInformation;
begin
  GetStartupInfo(SI);
  Result := CreateProcess(nil, PChar(FCommand),
    nil, nil, False, 0, nil, nil, SI, PI);
  if Result and Assigned(FOnRun) then
    FOnRun(Self, PI.hProcess, FCommand)
end;

procedure TRunButton.SetCommand(const Value: String);
begin
  if Length(Value) <= MAX_PATH then
    FCommand := Value
  else
    raise EWin32Error.Create('Command line too long. Tough.')
end;

end.
